### 3.5 Options Controlling C++ Dialect

This section describes the command-line options that are only meaningful for C++ programs. You can also use most of the GNU compiler options regardless of what language your program is in. For example, you might compile a file `firstClass.C` like this:

         g++ -g -frepo -O -c firstClass.C

In this example, only `-frepo` is an option meant only for C++ programs; you can use the other options with any language supported by GCC.

Here is a list of options that are only for compiling C++ programs:

`-fabi-version=`n
  Use version n of the C++ ABI. The default is version 2.

  Version 0 refers to the version conforming most closely to the C++ ABI specification. Therefore, the ABI obtained using version 0 will change in different versions of G++ as ABI bugs are fixed.

  Version 1 is the version of the C++ ABI that first appeared in G++ 3.2.

  Version 2 is the version of the C++ ABI that first appeared in G++ 3.4.

  Version 3 corrects an error in mangling a constant address as a template argument.

  Version 4, which first appeared in G++ 4.5, implements a standard mangling for vector types.

  Version 5, which first appeared in G++ 4.6, corrects the mangling of attribute const/volatile on function pointer types, decltype of a plain decl, and use of a function parameter in the declaration of another parameter.

  Version 6, which first appeared in G++ 4.7, corrects the promotion behavior of C++11 scoped enums and the mangling of template argument packs, const/static_cast, prefix ++ and –, and a class scope function used as a template argument.

  See also `-Wabi`.

`-fno-access-control`
  Turn off all access checking. This switch is mainly useful for working around bugs in the access control code.
`-fcheck-new`
  Check that the pointer returned by `operator new` is non-null before attempting to modify the storage allocated. This check is normally unnecessary because the C++ standard specifies that `operator new` only returns `0` if it is declared ‘`throw()`’, in which case the compiler always checks the return value even without this option. In all other cases, when `operator new` has a non-empty exception specification, memory exhaustion is signalled by throwing `std::bad_alloc`. See also ‘`new (nothrow)`’.
`-fconstexpr-depth=`n
  Set the maximum nested evaluation depth for C++11 constexpr functions to n. A limit is needed to detect endless recursion during constant expression evaluation. The minimum specified by the standard is 512.
`-fdeduce-init-list`
  Enable deduction of a template type parameter as `std::initializer_list` from a brace-enclosed initializer list, i.e.

                template <class T> auto forward(T t) -> decltype (realfn (t))
                {
                  return realfn (t);
                }

                void f()
                {
                  forward({1,2}); // call forward<std::initializer_list<int>>
                }

  This deduction was implemented as a possible extension to the originally proposed semantics for the C++11 standard, but was not part of the final standard, so it is disabled by default. This option is deprecated, and may be removed in a future version of G++.

`-ffriend-injection`
  Inject friend functions into the enclosing namespace, so that they are visible outside the scope of the class in which they are declared. Friend functions were documented to work this way in the old Annotated C++ Reference Manual, and versions of G++ before 4.1 always worked that way. However, in ISO C++ a friend function that is not declared in an enclosing scope can only be found using argument dependent lookup. This option causes friends to be injected as they were in earlier releases.

  This option is for compatibility, and may be removed in a future release of G++.

`-fno-elide-constructors`
  The C++ standard allows an implementation to omit creating a temporary that is only used to initialize another object of the same type. Specifying this option disables that optimization, and forces G++ to call the copy constructor in all cases.
`-fno-enforce-eh-specs`
  Don't generate code to check for violation of exception specifications at run time. This option violates the C++ standard, but may be useful for reducing code size in production builds, much like defining ‘`NDEBUG`’. This does not give user code permission to throw exceptions in violation of the exception specifications; the compiler still optimizes based on the specifications, so throwing an unexpected exception results in undefined behavior at run time.
`-fextern-tls-init`
`-fno-extern-tls-init`
  The C++11 and OpenMP standards allow ‘`thread_local`’ and ‘`threadprivate`’ variables to have dynamic (runtime) initialization. To support this, any use of such a variable goes through a wrapper function that performs any necessary initialization. When the use and definition of the variable are in the same translation unit, this overhead can be optimized away, but when the use is in a different translation unit there is significant overhead even if the variable doesn't actually need dynamic initialization. If the programmer can be sure that no use of the variable in a non-defining TU needs to trigger dynamic initialization (either because the variable is statically initialized, or a use of the variable in the defining TU will be executed before any uses in another TU), they can avoid this overhead with the `-fno-extern-tls-init` option.

  On targets that support symbol aliases, the default is `-fextern-tls-init`. On targets that do not support symbol aliases, the default is `-fno-extern-tls-init`.

`-ffor-scope`
`-fno-for-scope`
  If `-ffor-scope` is specified, the scope of variables declared in a for-init-statement is limited to the ‘`for`’ loop itself, as specified by the C++ standard. If `-fno-for-scope` is specified, the scope of variables declared in a for-init-statement extends to the end of the enclosing scope, as was the case in old versions of G++, and other (traditional) implementations of C++.

  If neither flag is given, the default is to follow the standard, but to allow and give a warning for old-style code that would otherwise be invalid, or have different behavior.

`-fno-gnu-keywords`
  Do not recognize `typeof` as a keyword, so that code can use this word as an identifier. You can use the keyword `__typeof__` instead. `-ansi` implies `-fno-gnu-keywords`.
`-fno-implicit-templates`
  Never emit code for non-inline templates that are instantiated implicitly (i.e. by use); only emit code for explicit instantiations. See Template Instantiation, for more information.
`-fno-implicit-inline-templates`
  Don't emit code for implicit instantiations of inline templates, either. The default is to handle inlines differently so that compiles with and without optimization need the same set of explicit instantiations.
`-fno-implement-inlines`
  To save space, do not emit out-of-line copies of inline functions controlled by ‘`#pragma implementation`’. This causes linker errors if these functions are not inlined everywhere they are called.
`-fms-extensions`
  Disable Wpedantic warnings about constructs used in MFC, such as implicit int and getting a pointer to member function via non-standard syntax.
`-fno-nonansi-builtins`
  Disable built-in declarations of functions that are not mandated by ANSI/ISO C. These include `ffs`, `alloca`, `_exit`, `index`, `bzero`, `conjf`, and other related functions.
`-fnothrow-opt`
  Treat a `throw()` exception specification as if it were a `noexcept` specification to reduce or eliminate the text size overhead relative to a function with no exception specification. If the function has local variables of types with non-trivial destructors, the exception specification actually makes the function smaller because the EH cleanups for those variables can be optimized away. The semantic effect is that an exception thrown out of a function with such an exception specification results in a call to `terminate` rather than `unexpected`.
`-fno-operator-names`
  Do not treat the operator name keywords `and`, `bitand`, `bitor`, `compl`, `not`, `or` and `xor` as synonyms as keywords.
`-fno-optional-diags`
  Disable diagnostics that the standard says a compiler does not need to issue. Currently, the only such diagnostic issued by G++ is the one for a name having multiple meanings within a class.
`-fpermissive`
  Downgrade some diagnostics about nonconformant code from errors to warnings. Thus, using `-fpermissive` allows some nonconforming code to compile.
`-fno-pretty-templates`
  When an error message refers to a specialization of a function template, the compiler normally prints the signature of the template followed by the template arguments and any typedefs or typenames in the signature (e.g. `void f(T) [with T = int]` rather than `void f(int)`) so that it's clear which template is involved. When an error message refers to a specialization of a class template, the compiler omits any template arguments that match the default template arguments for that template. If either of these behaviors make it harder to understand the error message rather than easier, you can use `-fno-pretty-templates` to disable them.
`-frepo`
  Enable automatic template instantiation at link time. This option also implies `-fno-implicit-templates`. See Template Instantiation, for more information.
`-fno-rtti`
  Disable generation of information about every class with virtual functions for use by the C++ run-time type identification features (‘`dynamic_cast`’ and ‘`typeid`’). If you don't use those parts of the language, you can save some space by using this flag. Note that exception handling uses the same information, but G++ generates it as needed. The ‘`dynamic_cast`’ operator can still be used for casts that do not require run-time type information, i.e. casts to `void *` or to unambiguous base classes.
`-fstats`
  Emit statistics about front-end processing at the end of the compilation. This information is generally only useful to the G++ development team.
`-fstrict-enums`
  Allow the compiler to optimize using the assumption that a value of enumerated type can only be one of the values of the enumeration (as defined in the C++ standard; basically, a value that can be represented in the minimum number of bits needed to represent all the enumerators). This assumption may not be valid if the program uses a cast to convert an arbitrary integer value to the enumerated type.
`-ftemplate-backtrace-limit=`n
  Set the maximum number of template instantiation notes for a single warning or error to n. The default value is 10.
`-ftemplate-depth=`n
  Set the maximum instantiation depth for template classes to n. A limit on the template instantiation depth is needed to detect endless recursions during template class instantiation. ANSI/ISO C++ conforming programs must not rely on a maximum depth greater than 17 (changed to 1024 in C++11). The default value is 900, as the compiler can run out of stack space before hitting 1024 in some situations.
`-fno-threadsafe-statics`
  Do not emit the extra code to use the routines specified in the C++ ABI for thread-safe initialization of local statics. You can use this option to reduce code size slightly in code that doesn't need to be thread-safe.
`-fuse-cxa-atexit`
  Register destructors for objects with static storage duration with the `__cxa_atexit` function rather than the `atexit` function. This option is required for fully standards-compliant handling of static destructors, but only works if your C library supports `__cxa_atexit`.
`-fno-use-cxa-get-exception-ptr`
  Don't use the `__cxa_get_exception_ptr` runtime routine. This causes `std::uncaught_exception` to be incorrect, but is necessary if the runtime routine is not available.
`-fvisibility-inlines-hidden`
  This switch declares that the user does not attempt to compare pointers to inline functions or methods where the addresses of the two functions are taken in different shared objects.

  The effect of this is that GCC may, effectively, mark inline methods with `__attribute__ ((visibility ("hidden")))` so that they do not appear in the export table of a DSO and do not require a PLT indirection when used within the DSO. Enabling this option can have a dramatic effect on load and link times of a DSO as it massively reduces the size of the dynamic export table when the library makes heavy use of templates.

  The behavior of this switch is not quite the same as marking the methods as hidden directly, because it does not affect static variables local to the function or cause the compiler to deduce that the function is defined in only one shared object.

  You may mark a method as having a visibility explicitly to negate the effect of the switch for that method. For example, if you do want to compare pointers to a particular inline method, you might mark it as having default visibility. Marking the enclosing class with explicit visibility has no effect.

  Explicitly instantiated inline methods are unaffected by this option as their linkage might otherwise cross a shared library boundary. See Template Instantiation.

`-fvisibility-ms-compat`
  This flag attempts to use visibility settings to make GCC's C++ linkage model compatible with that of Microsoft Visual Studio.

  The flag makes these changes to GCC's linkage model:

  1. It sets the default visibility to `hidden`, like `-fvisibility=hidden`.
  2. Types, but not their members, are not hidden by default.
  3. The One Definition Rule is relaxed for types without explicit visibility specifications that are defined in more than one shared object: those declarations are permitted if they are permitted when this option is not used.

  In new code it is better to use `-fvisibility=hidden` and export those classes that are intended to be externally visible. Unfortunately it is possible for code to rely, perhaps accidentally, on the Visual Studio behavior.

  Among the consequences of these changes are that static data members of the same type with the same name but defined in different shared objects are different, so changing one does not change the other; and that pointers to function members defined in different shared objects may not compare equal. When this flag is given, it is a violation of the ODR to define types with the same name differently.

`-fvtable-verify=`std|preinit|none
  Turn on (or off, if using `-fvtable-verify=none`) the security feature that verifies at runtime, for every virtual call that is made, that the vtable pointer through which the call is made is valid for the type of the object, and has not been corrupted or overwritten. If an invalid vtable pointer is detected (at runtime), an error is reported and execution of the program is immediately halted.

  This option causes runtime data structures to be built, at program start up, for verifying the vtable pointers. The options `std` and `preinit` control the timing of when these data structures are built. In both cases the data structures are built before execution reaches 'main'. The `-fvtable-verify=std` causes these data structure to be built after the shared libraries have been loaded and initialized. `-fvtable-verify=preinit` causes them to be built before the shared libraries have been loaded and initialized.

  If this option appears multiple times in the compiler line, with different values specified, 'none' will take highest priority over both 'std' and 'preinit'; 'preinit' will take priority over 'std'.

`-fvtv-debug`
  Causes debug versions of the runtime functions for the vtable verification feature to be called. This assumes the `-fvtable-verify=std` or `-fvtable-verify=preinit` has been used. This flag will also cause the compiler to keep track of which vtable pointers it found for each class, and record that information in the file “vtv_set_ptr_data.log”, in the dump file directory on the user's machine.

  Note: This feature APPENDS data to the log file. If you want a fresh log file, be sure to delete any existing one.

`-fvtv-counts`
  This is a debugging flag. When used in conjunction with `-fvtable-verify=std` or `-fvtable-verify=preinit`, this causes the compiler to keep track of the total number of virtual calls it encountered and the number of verifications it inserted. It also counts the number of calls to certain runtime library functions that it inserts. This information, for each compilation unit, is written to a file named “vtv_count_data.log”, in the dump_file directory on the user's machine. It also counts the size of the vtable pointer sets for each class, and writes this information to “vtv_class_set_sizes.log” in the same directory.

  Note: This feature APPENDS data to the log files. To get a fresh log files, be sure to delete any existing ones.

`-fno-weak`
  Do not use weak symbol support, even if it is provided by the linker. By default, G++ uses weak symbols if they are available. This option exists only for testing, and should not be used by end-users; it results in inferior code and has no benefits. This option may be removed in a future release of G++.
`-nostdinc++`
  Do not search for header files in the standard directories specific to C++, but do still search the other standard directories. (This option is used when building the C++ library.)

In addition, these optimization, warning, and code generation options have meanings only for C++ programs:

`-Wabi` (C, Objective-C, C++ and Objective-C++ only)
  Warn when G++ generates code that is probably not compatible with the vendor-neutral C++ ABI. Although an effort has been made to warn about all such cases, there are probably some cases that are not warned about, even though G++ is generating incompatible code. There may also be cases where warnings are emitted even though the code that is generated is compatible.

  You should rewrite your code to avoid these warnings if you are concerned about the fact that code generated by G++ may not be binary compatible with code generated by other compilers.

  The known incompatibilities in `-fabi-version=2` (the default) include:

  - A template with a non-type template parameter of reference type is mangled incorrectly:

                       extern int N;
                       template <int &> struct S {};
                       void n (S<N>) {2}

    This is fixed in `-fabi-version=3`.

  - SIMD vector types declared using `__attribute ((vector_size))` are mangled in a non-standard way that does not allow for overloading of functions taking vectors of different sizes.

    The mangling is changed in `-fabi-version=4`.

  The known incompatibilities in `-fabi-version=1` include:

  - Incorrect handling of tail-padding for bit-fields. G++ may attempt to pack data into the same byte as a base class. For example:

                       struct A { virtual void f(); int f1 : 1; };
                       struct B : public A { int f2 : 1; };

    In this case, G++ places `B::f2` into the same byte as `A::f1`; other compilers do not. You can avoid this problem by explicitly padding `A` so that its size is a multiple of the byte size on your platform; that causes G++ and other compilers to lay out `B` identically.

  - Incorrect handling of tail-padding for virtual bases. G++ does not use tail padding when laying out virtual bases. For example:

                       struct A { virtual void f(); char c1; };
                       struct B { B(); char c2; };
                       struct C : public A, public virtual B {};

    In this case, G++ does not place `B` into the tail-padding for `A`; other compilers do. You can avoid this problem by explicitly padding `A` so that its size is a multiple of its alignment (ignoring virtual base classes); that causes G++ and other compilers to lay out `C` identically.

  - Incorrect handling of bit-fields with declared widths greater than that of their underlying types, when the bit-fields appear in a union. For example:

                       union U { int i : 4096; };

    Assuming that an `int` does not have 4096 bits, G++ makes the union too small by the number of bits in an `int`.

  - Empty classes can be placed at incorrect offsets. For example:

                       struct A {};

                       struct B {
                         A a;
                         virtual void f ();
                       };

                       struct C : public B, public A {};

    G++ places the `A` base class of `C` at a nonzero offset; it should be placed at offset zero. G++ mistakenly believes that the `A` data member of `B` is already at offset zero.

  - Names of template functions whose types involve `typename` or template template parameters can be mangled incorrectly.

                       template <typename Q>
                       void f(typename Q::X) {}

                       template <template <typename> class Q>
                       void f(typename Q<int>::X) {}

    Instantiations of these templates may be mangled incorrectly.

  It also warns about psABI-related changes. The known psABI changes at this point include:

  - For SysV/x86-64, unions with `long double` members are passed in memory as specified in psABI. For example:

                       union U {
                         long double ld;
                         int i;
                       };

    `union U` is always passed in memory.

`-Wctor-dtor-privacy` (C++ and Objective-C++ only)
  Warn when a class seems unusable because all the constructors or destructors in that class are private, and it has neither friends nor public static member functions. Also warn if there are no non-private methods, and there's at least one private member function that isn't a constructor or destructor.
`-Wdelete-non-virtual-dtor` (C++ and Objective-C++ only)
  Warn when ‘`delete`’ is used to destroy an instance of a class that has virtual functions and non-virtual destructor. It is unsafe to delete an instance of a derived class through a pointer to a base class if the base class does not have a virtual destructor. This warning is enabled by `-Wall`.
`-Wliteral-suffix` (C++ and Objective-C++ only)
  Warn when a string or character literal is followed by a ud-suffix which does not begin with an underscore. As a conforming extension, GCC treats such suffixes as separate preprocessing tokens in order to maintain backwards compatibility with code that uses formatting macros from `<inttypes.h>`. For example:

                #define __STDC_FORMAT_MACROS
                #include <inttypes.h>
                #include <stdio.h>

                int main() {
                  int64_t i64 = 123;
                  printf("My int64: %"PRId64"\n", i64);
                }

  In this case, `PRId64` is treated as a separate preprocessing token.

  This warning is enabled by default.

`-Wnarrowing` (C++ and Objective-C++ only)
  Warn when a narrowing conversion prohibited by C++11 occurs within ‘`{ }`’, e.g.

                int i = { 2.2 }; // error: narrowing from double to int

  This flag is included in `-Wall` and `-Wc++11-compat`.

  With `-std=c++11`, `-Wno-narrowing` suppresses the diagnostic required by the standard. Note that this does not affect the meaning of well-formed code; narrowing conversions are still considered ill-formed in SFINAE context.

`-Wnoexcept` (C++ and Objective-C++ only)
  Warn when a noexcept-expression evaluates to false because of a call to a function that does not have a non-throwing exception specification (i.e. ‘`throw()`’ or ‘`noexcept`’) but is known by the compiler to never throw an exception.
`-Wnon-virtual-dtor` (C++ and Objective-C++ only)
  Warn when a class has virtual functions and an accessible non-virtual destructor itself or in an accessible polymorphic base class, in which case it is possible but unsafe to delete an instance of a derived class through a pointer to the class itself or base class. This warning is automatically enabled if `-Weffc++` is specified.
`-Wreorder` (C++ and Objective-C++ only)
  Warn when the order of member initializers given in the code does not match the order in which they must be executed. For instance:

                struct A {
                  int i;
                  int j;
                  A(): j (0), i (1) { }
                };

  The compiler rearranges the member initializers for ‘`i`’ and ‘`j`’ to match the declaration order of the members, emitting a warning to that effect. This warning is enabled by `-Wall`.

`-fext-numeric-literals` (C++ and Objective-C++ only)
  Accept imaginary, fixed-point, or machine-defined literal number suffixes as GNU extensions. When this option is turned off these suffixes are treated as C++11 user-defined literal numeric suffixes. This is on by default for all pre-C++11 dialects and all GNU dialects: `-std=c++98`, `-std=gnu++98`, `-std=gnu++11`, `-std=gnu++1y`. This option is off by default for ISO C++11 onwards (`-std=c++11`, ...).

The following `-W...` options are not affected by `-Wall`.

`-Weffc++` (C++ and Objective-C++ only)
  Warn about violations of the following style guidelines from Scott Meyers' Effective C++ series of books:
  - Define a copy constructor and an assignment operator for classes with dynamically-allocated memory.
  - Prefer initialization to assignment in constructors.
  - Have `operator=` return a reference to `*this`.
  - Don't try to return a reference when you must return an object.
  - Distinguish between prefix and postfix forms of increment and decrement operators.
  - Never overload `&&`, `||`, or `,`.

  This option also enables `-Wnon-virtual-dtor`, which is also one of the effective C++ recommendations. However, the check is extended to warn about the lack of virtual destructor in accessible non-polymorphic bases classes too.

  When selecting this option, be aware that the standard library headers do not obey all of these guidelines; use ‘`grep -v`’ to filter out those warnings.

`-Wstrict-null-sentinel` (C++ and Objective-C++ only)
  Warn about the use of an uncasted `NULL` as sentinel. When compiling only with GCC this is a valid sentinel, as `NULL` is defined to `__null`. Although it is a null pointer constant rather than a null pointer, it is guaranteed to be of the same size as a pointer. But this use is not portable across different compilers.
`-Wno-non-template-friend` (C++ and Objective-C++ only)
  Disable warnings when non-templatized friend functions are declared within a template. Since the advent of explicit template specification support in G++, if the name of the friend is an unqualified-id (i.e., ‘`friend foo(int)`’), the C++ language specification demands that the friend declare or define an ordinary, nontemplate function. (Section 14.5.3). Before G++ implemented explicit specification, unqualified-ids could be interpreted as a particular specialization of a templatized function. Because this non-conforming behavior is no longer the default behavior for G++, `-Wnon-template-friend` allows the compiler to check existing code for potential trouble spots and is on by default. This new compiler behavior can be turned off with `-Wno-non-template-friend`, which keeps the conformant compiler code but disables the helpful warning.
`-Wold-style-cast` (C++ and Objective-C++ only)
  Warn if an old-style (C-style) cast to a non-void type is used within a C++ program. The new-style casts (‘`dynamic_cast`’, ‘`static_cast`’, ‘`reinterpret_cast`’, and ‘`const_cast`’) are less vulnerable to unintended effects and much easier to search for.
`-Woverloaded-virtual` (C++ and Objective-C++ only)
  Warn when a function declaration hides virtual functions from a base class. For example, in:

                struct A {
                  virtual void f();
                };

                struct B: public A {
                  void f(int);
                };

  the `A` class version of `f` is hidden in `B`, and code like:

                B* b;
                b->f();

  fails to compile.

`-Wno-pmf-conversions` (C++ and Objective-C++ only)
  Disable the diagnostic for converting a bound pointer to member function to a plain pointer.
`-Wsign-promo` (C++ and Objective-C++ only)
  Warn when overload resolution chooses a promotion from unsigned or enumerated type to a signed type, over a conversion to an unsigned type of the same size. Previous versions of G++ tried to preserve unsignedness, but the standard mandates the current behavior.